%% Luogo delle radici per progetto regolatore integrale R1(s)=KR/s 
 numL=0.05*[1 3];
 denL=poly([0 -1 -2 -4]);
 figure
 rlocus(numL,denL)
 %xlim([-5 2])
 
 %% Simulazione con regolatore R1
 % Aprire il file Simulink RIT_05_R1.slx
 Tsim=35;
 KR=19;
 r=1;
 d=0;
 sim('RIT_05_R1');
 
figure
plot(y.Time,y.Data,'LineWidth',2),grid
title('Uscita y(t)con set point unitario e disturbo nullo')
xlabel('Time [sec]')
set(gca,'FontSize',14)
%ylim([0 1.1])

figure
plot(y.Time,y.Data,'LineWidth',2),grid
title('Uscita y(t)con set point unitario e disturbo nullo (zoom)')
xlabel('Time [sec]')
set(gca,'FontSize',14)
xlim([12 20])
ylim([0.9 1.05])

d=1;
sim('RIT_05_R1');
figure
plot(y.Time,y.Data,'LineWidth',2),grid
title('Uscita y(t)con set point e disturbo unitari')
xlabel('Time [sec]')
set(gca,'FontSize',14)

%% Luogo delle radici per progetto regolatore proporzionale integrale R2(s)=KR(s+1)/s 
 numL=0.05*[1 3];
 denL=poly([0 -2 -4]);
 figure
 rlocus(numL,denL)
 %xlim([-5 2])
 
 %% Simulazione con regolatore R2
 % Aprire il file Simulink RIT_05_R2.slx
 Tsim=35;
 KR=70;
 r=1;
 d=0;
 sim('RIT_05_R2');
 figure
 plot(y.Time,y.Data,'LineWidth',2),grid
 title('Uscita y(t) con r(t)=1 e d(t)=0')
 xlabel('Time [sec]')
 set(gca,'FontSize',14)
 sim('RIT_05_R2');
 
d=1;
sim('RIT_05_R2');
figure
plot(y.Time,y.Data,'LineWidth',2),grid
title('Uscita y(t) con r(t)=1 e d(t)=1')
xlabel('Time [sec]')
set(gca,'FontSize',14)
sim('RIT_05_R2');

%% bande passanti a ciclo chiuso
s=tf('s');
P=tf(0.05*[1 3],poly([-1 -2 -4]))
R1=tf(19,[1 0])
R2=tf(70*[1 1],[1 0])
W1=R1*P/(1+R1*P)*exp(-8*s)
W2=R2*P/(1+R2*P)*exp(-8*s)
bode(W1,W2)
legend('Con regolatore R_1','Con regolatore R_2')